#include <Arduino.h>
#include <NewPing.h>
#include "NewTone.h"
#include "Sonar.h"
#include "steparr.h"
#include "pins.h"

piezo piezoFst = {FIRST_PIEZO_PIN, (unsigned int) millis()}; // the piezo is connected to analog pin 0
piezo piezoSnd = {SECOND_PIEZO_PIN, (unsigned int) millis()}; // the piezo is connected to analog pin 1

unsigned long lastStep;
double speed = DEF_SPEED; // (cm/s)
steparr steps;
int stepLedState = LOW;
int k;
int pitch;

NewPing sonar(SONAR_TRIG_PIN, SONAR_ECHO_PIN);

void setup() {
  digitalWrite(SPEAKER_PIN, LOW);
  pinMode(STEPS_PIN, OUTPUT);
  pinMode(SPEAKER_PIN, OUTPUT);
  reset(&steps);
  Serial.begin(9600);
}

void loop() {
  double stepL;
  int obstacle;
  double safetyD;
  piezo *fst = &piezoFst;
  piezo *snd = &piezoSnd;
  detectStep(fst, onStep);
  detectStep(snd, onStep);
  if (millis() - lastStep > STEPS_RESET) reset(&steps);

  // update speed
  if (steps.avgStepT == 0) {
    speed = 0;
  } else {
    stepL = (analogRead(POT_PIN) - 512) * ((double) STEP_DELTA / 512) + DEF_STEP_L; // analogRead range [0, 1023]
    speed = stepL / steps.avgStepT * 1000;
  }

  // detect obstacle
  if (speed != 0) {
    obstacle = sonar.ping_cm();

    safetyD = speed * (REFLEX_T + 2 + steps.lastStepT) / 1000; // distance covered until reaction + 2 steps
    // Serial.print(safetyD);
    // Serial.print(" ");
    // Serial.println(obstacle);
    if (obstacle > 0 && obstacle <= safetyD ) {

      delay(100);

      k = obstacle/20;

  //    switch(k) {
  //      case
//      }
      if (k<1) { //sve od [0, 20>cm
         analogWrite(SPEAKER_PIN, 70);
         NewTone(HEADPHONE_PIN,1000);
       delay(600);
       analogWrite(SPEAKER_PIN, 0);
       noNewTone(HEADPHONE_PIN);
          delay(30);}
      else if(k==1){  //sve od [20,40>cm
        analogWrite(SPEAKER_PIN, 60);
        NewTone(HEADPHONE_PIN,900);

         delay(50);
      analogWrite(SPEAKER_PIN, 0);
      noNewTone(HEADPHONE_PIN);
         delay(50);
      analogWrite(SPEAKER_PIN, 60);
      NewTone(HEADPHONE_PIN,900);

         delay(50);
      analogWrite(SPEAKER_PIN, 0);
      noNewTone(HEADPHONE_PIN);
         delay(50);}

      else if(k==2){ //sve od [40,60>cm
      analogWrite(SPEAKER_PIN, 50);
      NewTone(HEADPHONE_PIN,800);
         delay(50);
      analogWrite(SPEAKER_PIN, 0);
      noNewTone(HEADPHONE_PIN);
         delay(100);
      analogWrite(SPEAKER_PIN, 50);
      NewTone(HEADPHONE_PIN,800);
         delay(50);
      analogWrite(SPEAKER_PIN, 0);
      noNewTone(HEADPHONE_PIN);
         delay(100);}

      else if(k==3){ //sve od [60,80>cm
      analogWrite(SPEAKER_PIN, 30);
      NewTone(HEADPHONE_PIN,500);
         delay(40);
      analogWrite(SPEAKER_PIN, 0);
      noNewTone(HEADPHONE_PIN);
         delay(150);
      analogWrite(SPEAKER_PIN, 30);
      NewTone(HEADPHONE_PIN,500);
         delay(40);
      analogWrite(SPEAKER_PIN, 0);
      noNewTone(HEADPHONE_PIN);
         delay(150);}

      else if (k==4){   //sve od [80,100>cm
      analogWrite(SPEAKER_PIN, 30);
      NewTone(HEADPHONE_PIN,500);
         delay(30);
      analogWrite(SPEAKER_PIN, 0);
      noNewTone(HEADPHONE_PIN);
         delay(250);
      analogWrite(SPEAKER_PIN, 30);
      NewTone(HEADPHONE_PIN,500);
         delay(30);
      analogWrite(SPEAKER_PIN, 0);
      noNewTone(HEADPHONE_PIN);
         delay(250);
         }
     else if(k<=15)   //sve od [100,300>cm
     {analogWrite(SPEAKER_PIN, 20);
       NewTone(HEADPHONE_PIN,400);
         delay(20);
      analogWrite(SPEAKER_PIN, 0);
      noNewTone(HEADPHONE_PIN);
         delay(600);}

      Serial.print("Udaljenost iznosi: ");
      Serial.print(obstacle);
      Serial.println("cm");
    }
  }

  delay(10);
}

void detectStep(piezo *p, void onStep()) {
  int val = analogRead(p->pin);
  unsigned int t = millis();
  if (val >= PIEZO_TRESH && (t - p->dbLast) > STEP_DEBOUNCE) {
    p->dbLast = t;
    onStep();
  }
}

void onStep() {
  lastStep = millis();
  appendStep(&steps);
  stepLedState = !stepLedState;
  digitalWrite(STEPS_PIN, stepLedState);
}
