#ifndef PARAMS
#define PARAMS

#define PIEZO_TRESH 100  // threshold value to decide when the detected vibration is a step or not
#define STEP_DEBOUNCE 800 // debounce for one leg stepping (max 200 steps per minute)

#define N_STEPS 5 // how many steps to take for speed calculation
#define DEF_STEP_T 500 // default step duration (ms)
#define DEF_STEP_L 71 // default step length (cm)
#define DEF_SPEED (DEF_STEP_L / DEF_STEP_T * 1000) // (cm/s) 71 / 500 * 1000 = 141
#define STEP_DELTA 20 // (cm) MAX_STEP_L = DEF_STEP_L + STEP_DELTA; MIN_STEP_L = DEF_STEP_L - STEP_DELTA
#define STEPS_RESET 2000 // how long to wait for timeout when not walking (ms)

#define REFLEX_T 400 // time to react (ms)

#endif /* end of include guard: PARAMS */
