#include <Arduino.h>
#include "steparr.h"

void appendStep(steparr *s) {
  int i, n;
  unsigned long prev, curr;
  int sum = 0;
  unsigned long t = millis();

  s->first = (s->first + 1) % N_STEPS;
  s->times[s->first] = millis();
  s->length = min(s->length + 1, 5);

  // calculate average step duration
  s->avgStepT = DEF_STEP_T;
  s->lastStepT = DEF_STEP_T;
  if (s->length == N_STEPS) {
    curr = s->times[s->first];
    for (i = 1; i < N_STEPS; i++) {
      n = s->first - i;
      if (n < 0) n += 5;

      prev = s->times[n];
      sum += curr - prev;
      curr = prev;
    }

    s->avgStepT = sum / N_STEPS;
  }

  if (s->length > 1) {
      n = s->first - 1;
      if (n < 0) n += 5;
      curr = s->times[s->first];
      prev = s->times[n];
      s->lastStepT = curr - prev;
  }
}

void reset(steparr *s) {
  if(s->first == -1) return; // already reseted
  s->first = -1;
  s->length = 0;
  s->avgStepT = 0;
  s->lastStepT = 0;
}
